<h3>__HEADER_TITLE__</h3>
<div id="cleared"></div>
<div id="accordion-vms" role='tablist' aria-multiselectable='true' class='o-accordion'>

</div>
<script>
    $(document).ready(function() {
        setInterval(getVmsTimer, 60000);
        // First time
        getVmsTimer();
    });

    String.prototype.lpad = function(length) {
        var str = this;
        while (str.length < length)
            str = "0" + str;
        return str;
    }


    function getContentForId(index, item) {
        var name=item['name'];
        var challenge=item['challenge'];
        var pingable=item['ping'];
        var uuid=item['uuid'];
        var master=item['master'];
        var address=item['address'];
        var team_owner=item['team'];
        var vnc=item['vnc'];
        var vnc_password=item['vnc_password'];
        var uptime=item['uptime']
        var lifetime=item['lifetime']
        var timelabel="Temps de fonctionnement :"
        if(lifetime){
            timelabel="Temps restant :";
            timeleft=Math.max(0, lifetime-uptime);
            if (timeleft > 60) {
                uptime=datehm(timeleft);
            } else {
                uptime="L'environnement virtuel est en cours d'arrêt ...";
            }
        } else if (uptime) {
            if (uptime<60) {
                uptime="Environnement virtuel en cours de démarrage ...";
            } else {
                uptime=datehm(uptime);
            }
        }

        var content=`<div class='card multi' id='vm_id_`+index+`'>
        <div class='card-header' role='tab' id='heading`+index+`'>

        <h5 class="mb-0">
            <button class="btn btn-lg btn-block" data-toggle="collapse" data-target="#collapse`+index+`" aria-expanded="false" aria-controls="collapse`+index+`">

        <span class='badge badge-vmid float-right mt-2'>Id VM : `+index+`</span>`;
        if (typeof team_owner!== 'undefined') {
            team_name=team_owner;
            if (Number.isInteger(team_owner))
                team_name="Team "+team_owner;
            content+=`<span class='badge badge-default-header' style='margin-right:5px;'>`+team_name+`</span>`;
        }
        content+=`<span class='badge badge-default-header' style='margin-right:5px;'>`+name+`</span>`;
        if (master)
            content+=`<span class='badge badge-danger'>| MASTER |</span>`;

        content+=`
        </button>
        </h5>
        </div>
        <div id="collapse`+index+`" class="collapse" role="tabpanel" aria-labelledby="heading`+index+`">
        <div class="card-body">`;

        content+=`
        <div class="row">
        <div class="col-sm">
        <div class="info-box">

        <div class="info-box-content">
        <span class="info-box-text">Adresse IP :</span>
        <span id="ip" class="info-box-number">`+address+`</span>
        </div>
        </div>
        </div>

        <div class="col-sm">
        <div class="info-box">
        <div class="info-box-content">
        <span class="info-box-text">`+timelabel+`</span>
        <span id="fonctionnement" class="info-box-number">`+uptime+`</span>
        </div>
        </div>
        </div>`;

        content+=`<div class="col-sm">
        <div class="info-box">
        <div class="info-box-content">
        <span id="actions" class="info-box-number">
            <div id='buttons' class='btn-group' role='group' aria-label='Actions'>
              <button id='bt_target_`+index+`' class='btn btn-secondary' type='button' onclick=' window.open(\"/started/`+index+`\",\"_blank\")'><i class='fas fa-wrench'></i> Gérer</button>`;

        if (vnc) {
            content+=`<button id='bt_novnc_`+index+`' class='btn btn-info' onclick=' window.open(\"/console?ch_id=`+challenge+`&vm_id=`+index+`&password=`+vnc_password+`\",\"_blank\")'><i class='fas fa-desktop'></i> Afficher</button>`;
        }
        content+=`</div></span>
        </div></div>
        </div>
        </div>
        </div>
        </div>
        </div>`;
        return content
    }

    function getVmsTimer() {
        $.ajax({
            url: '__URL_API_RQ__',
            dataType: 'json',
            }).done(function (response) {
            
            if (typeof response.success === 'undefined' || ! response.success)
                return;

            var content="";
            var list_item=getCollapseItemByClass();
            $.each(response, function(index, item) {
                if (typeof item == "object") {
                    content+=getContentForId(index, item);
                }
            });
            $("#accordion-vms").html(content);
            if(list_item.length > 0){
                setCollapseItem(list_item);
            }
        });
    };

    function getCollapseItemByClass() {
        var table =[];
        $("[class^='collapse show']").each(function( index ) {
                table.push($( this ).attr('id'));
                
        });
        return table;
    }
  
    function setCollapseItem(liste){
        liste.forEach(function(item, index, array) {
            $("#"+item).addClass("show");
        });     
    }

    </script>
